> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/uwp/basic-operations/open.md).

# Open a PDF in UWP

Learn how to open a PDF document from a memory buffer with full source code examples. Explore how to read and write PDF files efficiently using Apryse SDK. The Apryse uwp SDK streamlines secure docume

To open a PDF document.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
// open document from the filesystem
PDFDoc doc = new PDFDoc(fileName);

// optionally read a PDF document from a stream
MappedFile file = new MappedFile(fileName);
PDFDoc documentStream = new PDFDoc(file);

// or pass-in a memory buffer
ulong fileSize = file.WinRTGetFileSize();
FilterReader fileReader = new FilterReader(file);
byte[] memoryBuffer = new byte[(int)fileSize];
long bytesRead = fileReader.Read(memoryBuffer);
PDFDoc documentMemory = new PDFDoc(memoryBuffer);

// load from a URL
Uri url = new Uri("https://myserver.com/myfile.pdf");
HttpClient client = new HttpClient();
var file_content = client.GetByteArrayAsync(url);
PDFDoc doc = new PDFDoc(new MemoryStream(file_content));
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Read & write a PDF file from/to memory buffer](/uwp/get-started/samples.md#pdfdocmemory) Full source code which illustrates how to read/write a PDF document from/to memory buffer. This is useful for applications that work with dynamic PDF documents that don't need to be saved/read from a disk.

## About opening a document

The PDFDoc constructor creates a PDF document from scratch:

{% hint style="warning" %}
**PDFDoc.Close()**

When you are finished with a PDFDoc object, the PDFDoc.Close() method should be called to clean up memory, file handles, and resources.
{% endhint %}

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc new_doc = new PDFDoc();
```

{% endcode %}
{% endtab %}
{% endtabs %}

A newly-created document does not yet contain any pages. See the [accessing pages](/uwp/basic-operations/pages.md) section for details on creating new pages and working with existing pages.

Using Apryse SDK, you can open a document from a serialized file, from a memory buffer, or from a Filter stream.

To open an existing PDF document from a file, specify its file path in the PDFDoc constructor:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc new_doc = new PDFDoc(filename);
```

{% endcode %}
{% endtab %}
{% endtabs %}

Here's how to open an existing PDF document from a memory buffer:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
MappedFile file = new MappedFile(filename);
ulong fileSize = file.WinRTGetFileSize();
FilterReader fileReader = new FilterReader(file);
byte[] memoryBuffer = new byte[(int)fileSize];
long bytesRead = fileReader.Read(memoryBuffer);
PDFDoc doc = new PDFDoc(memoryBuffer);
```

{% endcode %}
{% endtab %}
{% endtabs %}

It's also easy to open a PDF document from a [MemoryFilter or a custom Filter ](/uwp/low-level-pdf-api/filters.md).

After creating a PDFDoc object, it's good practice to call `InitSecurityHandler()` on it. If the document is encrypted, calling the method will decrypt it. If the document is not encrypted, calling the method is harmless.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc doc = new PDFDoc(filename);
if (!doc.InitSecurityHandler())
{
  Console.WriteLine("Document authentication error...");
  return;
}
```

{% endcode %}
{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/uwp/basic-operations/open.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
